#ifndef LDAP_PLUGIN_H
#define LDAP_PLUGIN_H

#include <multisync.h>
#include <ldap.h>

typedef struct {
  client_connection commondata;
  sync_pair *sync_pair;
  connection_type conntype;
  char *servername;
  int serverport;
  char *binddn;
  char *pwd;
  char *searchbase;
  char *filter;
  char *syncdate;
  LDAP *ld;
} ldap_connection;

void ldap_load_state(ldap_connection *conn);
void ldap_save_state(ldap_connection *conn);
GList *ldap_do_get_deleted(gpointer data);
GList *ldap_do_get_changes(gpointer data);
void save_ldap_entry(ldap_connection *conn, char *comp, char *uid, sync_object_type objtype,
                             char *uidret, int *uidretlen);

LDAPMod **add_ldap_attribute(LDAPMod **attrs, int attrno, char* mod_type, char **values);

void delete_ldap_entry(ldap_connection *conn, char *comp, char *uid, sync_object_type objtype,
                             char *uidret, int *uidretlen);


char** sync_get_all_key_data(char *card, char *key);

#endif

